#pragma once
#ifndef __linux__
#include <Windows.h>
#include <stdio.h>
#else
#include <cstdint>
#include <iostream>

typedef uint32_t DWORD;
typedef int32_t LONG;
typedef uint8_t BYTE;

#define PACKED  __attribute__((packed))

/* bitmap file format according to msdn */

typedef struct PACKED {
    uint16_t bfType;
    DWORD bfSize;
    uint16_t bfReserved1, bfReserved2;
    DWORD bfOffBits;
} BITMAPFILEHEADER;

typedef struct PACKED {
    DWORD biSize;
    int32_t biWidth, biHeight;
    uint16_t biPlanes, biBitCount;
    DWORD biCompression;
    DWORD biSizeImage;
    int32_t biXPelsPerMeter, biYPelsPerMeter;
    DWORD biClrUsed, biClrImportant;
} BITMAPINFOHEADER;

#define BI_RGB 0L

typedef struct PACKED {
    uint8_t rgbBlue, rgbGreen, rgbRed, rgbReserved;
} RGBQUAD;
#warning "experimental BMP definitions"
#endif

class BmpHelper
{
public:
    static void SaveTo8bppBmpFile(const char* fname, LONG width, LONG height, unsigned char *buffer);
    static void Init8bppHeaders();

private:
    static LONG s8bppHeader_;
    static BITMAPFILEHEADER f8bppHeader_;
    static BITMAPINFOHEADER i8bppHeader_;
    static RGBQUAD p8bpp[256]; // greyscale.

    BmpHelper();
    ~BmpHelper();
    BmpHelper(const BmpHelper &);
    BmpHelper &operator=(const BmpHelper &);
};
