#include "SdlHelper.h"

SDL_Color BmpHelper::p8bpp[256];

void BmpHelper::Init8bppHeaders()
{
    SDL_Init(SDL_INIT_VIDEO);
    atexit(SDL_Quit);
    for (int i=0;i<256;i++) {
        p8bpp[i].r = i;
        p8bpp[i].g = i;
        p8bpp[i].b = i;
    }
}

/** prepends BMP headers in front of width x height array of 0-255 pixel values. */
void BmpHelper::SaveTo8bppBmpFile(const char *fname, LONG width, LONG height, unsigned char *buffer)
{
#define RGBMASK 0,0,0,0
    SDL_Surface *s = SDL_CreateRGBSurfaceFrom(buffer, width, height, 8, width, RGBMASK);
    if (s == 0) {
        fprintf(stderr, "SDL unable to create %lix%li 8bpp surface\n",width, height);
        exit(-1);
    }
    SDL_SetColors(s, p8bpp, 0, 256);
    SDL_SaveBMP(s, fname);
}
